<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * PayU Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2014 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Sept 2014
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');

class plgVmPaymentPayuForVirtuemart extends vmPSPlugin {

	public static $_this = false;
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		$this->_loggable = TRUE;
		$this->_debug = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = array(
    'payu_user'           => array('', 'char'),
    'payu_password'       => array('', 'char'),
    'payu_test'           => array('', 'char'),
    'payment_logos'       => array('', 'char'),
    'countries'           => array('', 'char'),
    'cost_per_transaction'=> array('', 'int'),
    'cost_percent_total'  => array('', 'int'),
    'min_amount'          => array('', 'int'),
    'max_amount'          => array('', 'int'),
    'tax_id'              => array(0, 'int'),
    'status_pending'      => array('', 'char'),
    'status_success'      => array('', 'char'),
    'status_canceled'     => array('', 'char'));
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment PayU Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
    'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
		'virtuemart_order_id' => 'int(1) UNSIGNED',
		'order_number' => 'char(64)',
		'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
		'payment_name' => 'varchar(5000)',
		'payment_order_total' => 'decimal(15,5) NOT NULL',
		'payment_currency' => 'smallint(1)',
    'payment_order_total'     => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
		'cost_per_transaction' => 'decimal(10,2)',
		'cost_percent_total' => 'decimal(10,2)',
		'tax_id' => 'smallint(1)',
    );
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=payuforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'payulic'=>$lic),'payuforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your PayU - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('payuforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['payulic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your PayU - Payment Gateway License Code', 'error');
        $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          //$chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          //if($chk!=$dchk)//check
          //{
          //  $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
          //  $application->enqueueMessage('Provided License code is wrong', 'error');
          //  return;
          //}
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->payu_user)) {
			vmInfo(JText::_('PayU Merchant ID Missing!!!'));
			return false;
		}
		if (empty($method->payu_password)) {
			vmInfo(JText::_('PayU Secret Key Missing!!!'));
			return false;
		}

		$myKey = $method->payu_password;
	  $myLiveUpdate = new LiveUpdatePayU($myKey);
		$myId = $method->payu_user;
	  $myLiveUpdate->setMerchant($myId);
    $myOrderRef	= $order['details']['BT']->order_number;
	  $myLiveUpdate->setOrderRef($myOrderRef);
	  $myOrderDate = date("Y-m-d H:i:s");
	  $myLiveUpdate->setOrderDate($myOrderDate);
	  
    $PayU_button='Click here to Pay';
    
    $vat_amnt=0;
    if(isset($order['details']['BT']->order_billTax))
    {
      $tmp_arr=json_decode($order['details']['BT']->order_billTax);
      $one="1";
      if(isset($tmp_arr->$one))
      {
        $vat_amnt=$tmp_arr->$one->calc_value;
      }
      $vat_amnt=round($vat_amnt);
    }
    $langs_arr=array('RO','EN','HU','RU','DE','FR','IT','ES','BG');
    $lang = JFactory::getLanguage(); 
    $languages = JLanguageHelper::getLanguages('lang_code'); 
    $languageCode = $languages[ $lang->getTag() ]->sef; 
    $languageCode=strtoupper($languageCode);
    if(!in_array($languageCode,$langs_arr))
    {
      $languageCode='EN';
    }

    $myLiveUpdate->setLanguage($languageCode);

    $PName		= array();
    $PCode		= array();
    $PPrice		= array();
    $PQTY		  = array();
    $PPriceType		= array();
    $PVAT		= array();
    foreach($order['items'] as $product)
    {
      $PName[]	= $product->order_item_name;
      $PCode[]	= $product->order_item_sku;
      $PPrice[]	= round($product->product_final_price,2);
      $PQTY[]		= $product->product_quantity;
      $PPriceType[]	= 'GROSS';
      $PVAT[]		= $vat_amnt;
    }
    
    if(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax)>0)
    {
      $PName[]	= 'Shipment Fee';
      $PCode[]	= 'SPTFEE';
      $PPrice[]	= round(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax),2);
      $PQTY[]		= 1;
      $PPriceType[]	= 'GROSS';
      $PVAT[]		= $vat_amnt;
		}
    if(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax)>0)
		{
      $PName[]	= 'Payment Fee';
      $PCode[]	= 'PMTFEE';
      $PPrice[]	= round(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax),2);
      $PQTY[]		= 1;
      $PPriceType[]	= 'GROSS';
      $PVAT[]		= $vat_amnt;
		}
		
    $myLiveUpdate->setOrderPName($PName);
    $myLiveUpdate->setOrderPCode($PCode);
    $myLiveUpdate->setOrderPrice($PPrice);
    $myLiveUpdate->setOrderPType($PPriceType);
    $myLiveUpdate->setOrderQTY($PQTY);
  	$myLiveUpdate->setOrderVAT($PVAT);

  	
  	$myLiveUpdate->setPricesCurrency($currency_code_3);
  	
  	$billing = array(
  		"billFName"				=> $usrBT->first_name,
  		"billLName"				=> $usrBT->last_name,
  		"billEmail" 			=> $usrBT->email,
  		"billPhone" 			=> $usrBT->phone_1,
  		"billAddress1"			=> $usrBT->address_1,
  		"billAddress2"			=> $usrBT->address_2,
  		"billZipCode"			=> $usrBT->zip,
  		"billCity"				=> $usrBT->city,
  		"billState"				=> isset($usrBT->virtuemart_state_id) ? ShopFunctions::getStateByID($usrBT->virtuemart_state_id,'state_name') : '',
  		"billCountryCode"		=> ShopFunctions::getCountryByID($usrBT->virtuemart_country_id,'country_2_code')
      //,"billCompany"		=> $usrBT->company// requires CUI if set
  	);
  	
		$delivery = array(
  		"deliveryFName"			=> $usrST->first_name,
  		"deliveryLName"			=> $usrST->last_name,
  		"deliveryPhone"			=> $usrST->phone_1,
  		"deliveryAddress1"		=> $usrST->address_1,
  		"deliveryAddress2"		=> $usrST->address_2,
  		"deliveryZipCode"		=> $usrST->zip,
  		"deliveryCity"			=> $usrST->city,
  		"deliveryState"			=> isset($usrST->virtuemart_state_id) ? ShopFunctions::getStateByID($usrST->virtuemart_state_id,'state_name') : '',
  		"deliveryCountryCode"	=> ShopFunctions::getCountryByID($usrST->virtuemart_country_id,'country_2_code')
      //,"deliveryCompany"		=> $usrST->company//
  	);
		

	  $myLiveUpdate->setBilling($billing);
	  $myLiveUpdate->setDelivery($delivery);
	  
  	if($method->payu_test=='TEST')
	  {
	    $myLiveUpdate->setTestMode(true);
	  }
	  /*
	  if($method->payu_auto=='yes')//required visa or mastercard, bad idea
	  {
	    $myLiveUpdate->setAutomode();
	  }
	  */
	  $return_url= JURI::root(). 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid');
  	$myLiveUpdate->setReturnURL($return_url);
    //echo $return_url;exit;
    //print_r($order);exit;
  	
		$html = '<div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PayUfrm" id="PayUfrm" action="'.$myLiveUpdate->liveUpdateURL.'" method="post">';
	  $html.= $myLiveUpdate->getLiveUpdateHTML();
		$html.= '<input type="submit"  value="'.$PayU_button.'" />';
		$html.= '</form></div>';
		//$html.=htmlentities($strPost);
		
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PayUfrm.submit();';
		$html.= ' </script>';
		
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		return true;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	
	  if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		$payment_name = $this->renderPluginName($method);
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return TRUE;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getPaymentStatus($method, $strStatus) {
		$new_status = '';
		if (strcmp($strStatus, 'OK') == 0) {
			$new_status = $method->status_success;
		}
    elseif (strcmp($strStatus, 'ABORT') == 0) {
			$new_status = $method->status_pending;
		}
    else {
			$new_status = $method->status_canceled;
		}
		return $new_status;
	}
	
	function _getPayuInternalData($virtuemart_order_id, $order_number='') {
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $paymentTable;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
    $db = &JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Thank You!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
		return $html;
	}
	function ArrayExpand($array){
  	$retval = "";
  	for($i = 0; $i < sizeof($array); $i++){
  		$size		= strlen(StripSlashes($array[$i]));
  		$retval	.= $size.StripSlashes($array[$i]);
  	}
  
  	return $retval;
  }
  function sendMailtoAdmin($msg)
  {
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->getValue( 'config.mailfrom' ),
        $config->getValue( 'config.fromname' ) );
     
    $mailer->setSender($sender);
    
    $mailer->addRecipient($config->getValue( 'config.mailfrom' ));
    $body   = $msg;
    $mailer->setSubject(juri::base().' - PayU Warning!');
    $mailer->isHTML(true);
    $mailer->Encoding = 'base64';
    $body=nl2br($body);
    $mailer->setBody($body);
    $send = $mailer->Send();
  }
	function plgVmOnPaymentNotification() {

    ini_set("mbstring.func_overload", 0);
    if(ini_get("mbstring.func_overload") > 2){  /* check if mbstring.func_overload is still set to overload strings(2)*/
    $this->sendMailtoAdmin("WARNING: mbstring.func_overload is set to overload strings and might cause problems\n");
    }
    
    if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		$payu_data = JRequest::get('post');
		if (!isset($payu_data['REFNOEXT'])) {
			return FALSE;
		}

		$order_number = $payu_data['REFNOEXT'];
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($payu_data['REFNOEXT']))) {
			return FALSE;
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return FALSE;
		}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		
    $pass		= $method->payu_password;	/* pass to compute HASH */
    $result		= ""; 				/* string for compute HASH for received data */
    $return		= ""; 				/* string to compute HASH for return result */
    $signature	= $payu_data['HASH'];	/* HASH received */

    /* read info received */
    while(list($key, $val) = each($_POST)){
    	$$key=$val;
    	/* get values */
    	if($key != "HASH"){
    
    		if(is_array($val)) $result .= $this->ArrayExpand($val);
    		else{
    			$size		= strlen(StripSlashes($val));
    			$result	.= $size.StripSlashes($val);
    		}
    	}
    }

    $date_return = date("YmdHis");

    $return = strlen($_POST["IPN_PID"][0]).$_POST["IPN_PID"][0].strlen($_POST["IPN_PNAME"][0]).$_POST["IPN_PNAME"][0];
    $return .= strlen($_POST["IPN_DATE"]).$_POST["IPN_DATE"].strlen($date_return).$date_return;
    $hash =  $this->hmac($pass, $result); /* HASH for data received */
    $order_paid=0;
    //print_r($_POST);
    $ORDERSTATUS=$_POST['ORDERSTATUS'];
    if($ORDERSTATUS=='COMPLETE' || $ORDERSTATUS=='PAYMENT_AUTHORIZED' || $ORDERSTATUS=='TEST'){
        $result_hash =  $this->hmac($pass, $return);
        $order_paid=1;
        ob_clean();
      	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
    }
    else if($ORDERSTATUS=='REFUND'){
      $result_hash =  $this->hmac($pass, $return);
      ob_clean();
    	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
      exit;
    }

    
		$modelOrder = VmModel::getModel('orders');
		$order = array();

		$order['customer_notified'] = 1;
    $order['comments']='';
		if ($order_paid == 1) {
			$order['order_status'] = $method->status_success;
		}
    else
    {
      $order['order_status'] = $method->status_canceled;
    }

		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
    exit;
	}
	function hmac ($key, $data) {
	   $b = 64; // byte length for md5
	   if (strlen($key) > $b) {
		   $key = pack("H*",md5($key));
	   }
	   $key  = str_pad($key, $b, chr(0x00));
	   $ipad = str_pad('', $b, chr(0x36));
	   $opad = str_pad('', $b, chr(0x5c));
	   $k_ipad = $key ^ $ipad ;
	   $k_opad = $key ^ $opad;
	   return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
	}
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
	  
    $this->convert_condition_amount($method);

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $this->getCartAmount($cart_prices);
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}
    
		return FALSE;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $paymentCounter);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}
	class LiveUpdatePayU {
		/*
		 * Class setup members.
		 * Set up the next members with the class default values.
		 * 
		 */

		/**
		 * Live Update URL
		 * This is the URL address where HTTP POST should be sent
		 * @var string
		 */
		var $liveUpdateURL			= "https://secure.epayment.ro/order/lu.php";


		/**
		 * Test Mode
		 * Set to true or or 1 for testing mode.
		 * @var boolean
		 */
		var $testMode 				= false;

		/**
		 * Language
		 * The language of the order interface. Default: "ro".
		 * @var string
		 */
		var $language 				= "";

		/**
		 * Secret Key
		 * Communication secret code. Used to create the HMAC signature.
		 * @var string
		 */
		var $secretKey 				= NULL;


		/**
		 * Merchant Identifier
		 * ePayment merchant code
		 * @var string
		 */
		var $merchant				= NULL;

		/**
		 * Merchant order reference
		 * @var string
		 */
		var $orderRef				= '';

		/**
		 * Order date
		 * @var string
		 */
		var $orderDate				= NULL;

		/**
		 * Product Names
		 * @var array
		 */
		var $orderPName				= array();

		/**
		 * Product Groups
		 * @var array
		 */
		var $orderPGroup			= array();
		
		/**
		 * Product Price Types (NET or GROSS)
		 * @var array
		 */
		var $orderPType			= array();
		
		/**
		 * Product Codes
		 * @var array
		 */
		var $orderPCode				= array();

		/**
		 * Product additional information
		 * @var array
		 */
		var $orderPInfo				= array();

		/**
		 * Product Prices (WITH NO VAT/TAXES if Product Price Types is not specified or NET)
		 * @var array
		 */
		var $orderPrice				= array();

		/**
		 * Product Quantities
		 * @var array
		 */
		var $orderQty				= array();

		/**
		 * Product VAT/Tax
		 * @var array
		 */
		var $orderVAT				= array();

		/**
		 * Product versions
		 * @var array
		 */
		var $orderVer				= array();

		/**
		 * Shipping cost
		 * @var float
		 */
		var $orderShipping			= 0;

		/**
		 * Order currency
		 * @var string
		 */
		var $pricesCurrency			= '';

		/**
		 * Order discount
		 * @var float
		 */
		var $discount				= 0;

		/**
		 * Destination city
		 * @var string.
		 */
		var $destinationCity		= '';

		/**
		 * Destination state
		 * @var string
		 */
		var $destinationState		= '';

		/**
		 * Destination country code
		 * @var integer
		 */
		var $destinationCountry		= '';

		/**
		 * Payment method
		 * @var string
		 */
		var $payMethod				= '';

		/**
		 * Order Hash
		 */
		var $orderHash				= '';



		/*
		 * Billing information
		 * Used to autofill the ordering form
		 */
		var $billing = array(
			"billFName"				=> '',
			"billLName"				=> '',
			"billCISerial"			=> '',
			"billCINumber"			=> '',
			"billCIIssuer"			=> '',
			"billCNP"				=> '',
			"billCompany"			=> '',
			"billFiscalCode" 		=> '',
			"billRegNumber" 		=> '',
			"billBank" 				=> '',
			"billBankAccount" 		=> '',
			"billEmail" 			=> '',
			"billPhone" 			=> '',
			"billFax" 				=> '',
			"billAddress1"			=> '',
			"billAddress2"			=> '',
			"billZipCode"			=> '',
			"billCity"				=> '',
			"billState"				=> '',
			"billCountryCode"		=> ''
		);
		var $billingSet				= false;


    var $automode = false;
    
    
		/*
		 * Delivery information.
		 * Used to autofill the ordering form
		 */
		var $delivery = array(
			"deliveryFName"			=> '',
			"deliveryLName"			=> '',
			"deliveryCompany"		=> '',
			"deliveryPhone"			=> '',
			"deliveryAddress1"		=> '',
			"deliveryAddress2"		=> '',
			"deliveryZipCode"		=> '',
			"deliveryCity"			=> '',
			"deliveryState"			=> '',
			"deliveryCountryCode"	=> ''
		);
		var $deliverySet			= false;


		/**
		 * LiveUpdate class constructor
		 *
		 * @access		public
		 * @param 		$secretKey		string
		 * @param 		$liveUpdateURL	string
		 * @param 		$debugMode		boolean
		 * @param 		$testMode		boolean
		 * @param 		$language		string
		 * @return		void
		 */
		function LiveUpdatePayU ($secretKey = '', $liveUpdateURL = 'https://secure.epayment.ro/order/lu.php', $debugMode = false, $testMode = false, $language = 'ro') {

			if (!empty($liveUpdateURL))
				if (!$this->setLiveUpdateURL($liveUpdateURL))
					$this->setLiveUpdateURL('https://secure.epayment.ro/order/lu.php');

			if (!empty($debugMode))
				$this->setDebugMode($debugMode);

			if (!empty($testMode))
				$this->setTestMode($testMode);

			if (!empty($language))
				$this->setLanguage($language);

			if (!empty($secretKey))
				$this->setSecretKey($secretKey);
		}

		/**
		 * setLiveUpdateURL class method
		 *
		 * Set up live update URL address
		 *
		 * @access		public
		 * @param 		$liveUpdateURL - live update url address
		 * @return 		boolean
		 */
		function setLiveUpdateURL($liveUpdateURL = 'https://secure.epayment.ro/order/lu.php') {
			if (!is_string($liveUpdateURL)) {		//invalid data type
				return false;
			}

			if (empty($liveUpdateURL)) {			//empty string
				return false;
			}

			$this->liveUpdateURL = $liveUpdateURL;	//everything is ok
			return true;
		}

		/**
		 * setTestMode class method
		 *
		 * This method sets the protocol in test mode or not.
		 * Set the parameter to 1 or true to use the class in test mode. For
		 * any other values, including false or 0, the class will work in 
		 * real mode
		 *
		 * @access		public
		 * @param 		$testMode - boolean
		 * @return 		boolean
		 */
		function setTestMode ($testMode = false) {
			switch ($testMode) {
				case true:
				case 1:
					$this->testMode = true;
					break;

				case false:
				case 0:
				default:
					$this->testMode = false;
			}
			return true;
		}
    function setAutomode($auto=true)
    {
      if($auto)
      {
        $this->automode=true;
      }
      else
      {
        $this->automode=false;
      }
    }
		/**
		 * setLanguage class method
		 *
		 * Sets the order language
		 *
		 * @access		public
		 * @param 		$language - string
		 * @return 		boolean
		 */
		function setLanguage ($language = 'RO') {
			$language = trim($language);
			switch ($language) {
				case 'RO':
					$this->language = 'RO';
					break;
				case 'HU':
					$this->language = 'HU';
					break;
				case 'RU':
					$this->language = 'RU';
					break;
				case 'DE':
					$this->language = 'DE';
					break;
				case 'FR':
					$this->language = 'FR';
					break;
				case 'IT':
					$this->language = 'IT';
					break;
				case 'ES':
					$this->language = 'ES';
					break;
				case 'BG':
					$this->language = 'BG';
					break;
				case 'EN':
				default:
					$this->language = 'EN';
			}
			return true;
		}

		/**
		 * setSecretKey class method
		 *
		 * Sets the secret key used for HASH signature
		 *
		 * @access		public
		 * @param 		$secretKey - string
		 * @return 		boolean
		 */
		function setSecretKey ($secretKey) {
			if (!is_string($secretKey)) {
				$this->secretKeyError = 'invalid type';
				return false;
			}

			if (empty($secretKey)) {
				$this->secretKeyError = 'empty string';
				return false;
			}

			if (strlen($secretKey) > 64) {
				$this->secretKeyError = 'secret key is length is too big';
				return false;
			}

			if (preg_match("/ /i",$secretKey)) {
				$this->secretKeyError = 'invalid format; white spaces not allowed';
				return false;
			}

			$this->secretKey = $secretKey;
			return true;
		}

		/**
		 * setMerchant method
		 *
		 * Sets up merchant identifier code
		 *
		 * @access		public
		 * @param 		$merchant string: merchat identifier
		 * @return 		boolean
		 */
		function setMerchant ($merchant) {
			if (!is_string($merchant))
				return false;

			if (empty($merchant))
				return false;

			$this->merchant = $merchant;
			return true;
		}

		/**
		 * setOrderRef method
		 *
		 * @access		public
		 * @param 		$orderRef string
		 * @return 		boolean
		 */
		function setOrderRef ($orderRef = '') {
			if (settype($orderRef, "string")) {
				if (strlen($orderRef) <= 32) {
					$this->orderRef = $orderRef;
					return true;
				}
				$this->orderRef = NULL;
				return false;
			}
			$this->orderRef = NULL;
			return false;
		}

		/**
		 * setOrderDate class method
		 *
		 * @access		public
		 * @param		$orderDate string
		 * @return		boolean
		 */
		function setOrderDate ($orderDate = '') {
			if (strtotime($orderDate) === -1) {
				$this->orderDate = NULL;
				return false;
			}

			$dateFormatPattern = "^((((19|20)(([02468][048])|([13579][26]))-02-29))|((20[0-9][0-9])|(19[0-9][0-9]))-((((0[1-9])|(1[0-2]))-((0[1-9])|(1\d)|(2[0-8])))|((((0[13578])|(1[02]))-31)|(((0[1,3-9])|(1[0-2]))-(29|30)))))^";

			if (!preg_match($dateFormatPattern, $orderDate)) {
				$this->orderDate = NULL;
				return false;
			}

			if(strtotime($orderDate) > strtotime(date("Y-m-d H:i:s"))) {
				$this->orderDate = NULL;
				return false;
			}

			$this->orderDate = $orderDate;
			return true;
		}

		/**
		 * setOrderPName class method
		 *
		 * Sets shopping cart product names
		 *
		 * @access		public
		 * @param		$orderPName array
		 * @return 		boolean
		 */
		function setOrderPName ($orderPName) {
			 if (!is_array($orderPName)) {
			 	$this->orderPName = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderPName)) {
				if (strlen($orderPName[$index]) > 155)
					$isValid = false;
				else
					$isValid = true;
				$index++;
			}
			if (!$isValid) {
				$this->orderPName = NULL;
				return false;
			}
			$this->orderPName = $orderPName;
			return true;
		}

		/**
		 * setOrderPGroup class method
		 *
		 * Sets products groups
		 *
		 * @access		public
		 * @param		$orderPGroup array
		 * @return 		boolean
		 */
		function setOrderPGroup ($orderPGroup) {
			 if (!is_array($orderPGroup)) {
			 	$this->orderPGroup = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderPGroup)) {
				if (strlen($orderPGroup[$index]) > 155)
					$isValid = false;
				else
					$isValid = true;
				$index++;
			}
			if (!$isValid) {
				$this->orderPGroup = NULL;
				return false;
			}
			$this->orderPGroup = $orderPGroup;
			return true;
		}
		
		/**
		 * setOrderPType class method
		 *
		 * Sets products price types
		 *
		 * @access		public
		 * @param		$orderPType array
		 * @return 		boolean
		 */
		function setOrderPType ($orderPType) {
			 if (!is_array($orderPType)) {
			 	$this->orderPType = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderPType)) {
				if (!in_array($orderPType[$index], array('GROSS', 'NET')))
					$isValid = false;
				else
					$isValid = true;
				$index++;
			}
			if (!$isValid) {
				$this->orderPType = NULL;
				return false;
			}
			$this->orderPType = $orderPType;
			return true;
		}
		
		/**
		 * setOrderPCode class method
		 *
		 * Sets shopping cart product codes
		 *
		 * @access		public
		 * @param		$orderPCode array
		 * @return		boolean
		 */
		function setOrderPCode ($orderPCode) {
			if (!is_array($orderPCode)) {
				$this->orderPCode = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderPCode)) {
				if (strlen($orderPCode[$index]) > 20)
					$isValid = false;
				else
					$isValid = true;
				$index++;
			}
			if (!$isValid) {
				$this->orderPCode = NULL;
				return false;
			}
			$this->orderPCode = $orderPCode;
			return true;
		}

		/**
		 * setOrderPInfo class method
		 *
		 * Sets additional information for the products in the shopping cart
		 *
		 * @access		public
		 * @param		$orderPInfo array
		 * @return 		boolean
		 */
		function setOrderPInfo ($orderPInfo) {
			if (!is_array($orderPInfo)) {
				$this->orderPInfo = NULL;
				return false;
			}
			$this->orderPInfo = $orderPInfo;
			return true;
		}

		/**
		 * setOrderPrice class method
		 *
		 * Sets product prices
		 *
		 * @access		public
		 * @param		$orderPrice array
		 * @return		boolean
		 */
		function setOrderPrice($orderPrice) {
			if (!is_array($orderPrice)) {
				$this->orderPrice = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderPrice)) {
				if (is_numeric($orderPrice[$index]) && $orderPrice[$index] > 0)
					$isValid = true;
				else
					$isValid = false;
				$index++;
			}
			if (!$isValid) {
				$this->orderPrice = NULL;
				return false;
			}
			$this->orderPrice = $orderPrice;
			return true;
		}

		/**
		 * setOrderQTY class method
		 *
		 * Sets quantities for each product in the shopping cart
		 * @access		public
		 * @param		$orderQty array
		 * @return		boolean
		 */
		function setOrderQTY ($orderQty) {
			if (!is_array($orderQty)) {
				$this->orderQty = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderQty)) {
				if (is_numeric($orderQty[$index]) && $orderQty[$index] > 0)
					$isValid = true;
				else
					$isValid = false;
				$index++;
			}
			if (!$isValid) {
				$this->orderQty = NULL;
				return false;
			}
			$this->orderQty = $orderQty;
			return true;
		}

		/**
		 * setOrderVAT class method
		 *
		 * Sets VAT for each product in the shopping cart
		 * @access		public
		 * @param		$orderVAT array
		 * @return		boolean
		 */
		function setOrderVAT ($orderVAT) {
			if (!is_array($orderVAT)) {
				$this->orderVAT = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderVAT)) {
				if (is_numeric($orderVAT[$index]) && $orderVAT[$index] >= 0 && $orderVAT[$index] < 100)
					$isValid = true;
				else
					$isValid = false;
				$index++;
			}
			if (!$isValid) {
				$this->orderVAT = NULL;
				return false;
			}
			$this->orderVAT = $orderVAT;
			return true;
		}

		/**
		 * setOrderVer class method
		 *
		 * Sets products versions
		 *
		 * @access		public
		 * @param		$orderVer array
		 * @return		boolean
		 */
		function setOrderVer ($orderVer) {
			if (!is_array($orderVer)) {
				$this->orderVer = NULL;
				return false;
			}
			$isValid = true;
			$index = 0;
			while ($isValid && $index < count($orderVer)) {
				if (settype($orderVer[$index], "string"))
					if (strlen($orderVer[$index]) < 51)
						$isValid = true;
					else
						$isValid = false;
				else
					$isValid = false;
				$index++;
			}
			if (!$isValid) {
				$this->orderVer = NULL;
				return false;
			}
			$this->orderVer = $orderVer;
			return true;
		}

		/**
		 * setOrderShipping
		 *
		 * Sets the order shipping costs
		 *
		 * @access		public
		 * @param		$orderShipping float
		 * @return		boolean
		 */
		function setOrderShipping ($orderShipping = 0) {
			if (is_numeric($orderShipping) && $orderShipping >= 0) {
				$this->orderShipping = $orderShipping;
				return true;
			} elseif (is_numeric($orderShipping) && $orderShipping < 0) {
				$this->orderShipping = -1;
				return true;
			}

			$this->orderShipping = NULL;
			return false;
		}

		/**
		 * setPricesCurrency
		 *
		 * Sets the prices currency
		 *
		 * @access		public
		 * @param		$pricesCurrency string[3]
		 * @return		true
		 */
		function setPricesCurrency ($pricesCurrency = 'RON') {
			$pricesCurrency = strtoupper(trim($pricesCurrency));
			switch ($pricesCurrency) {
				case 'ROL':
					$this->pricesCurrency = 'ROL';
					break;

				case 'EUR':
					$this->pricesCurrency = 'EUR';
					break;

				case 'USD':
					$this->pricesCurrency = 'USD';
					break;

				case 'GBP':
					$this->pricesCurrency = 'GBP';
					break;

				case 'RON':
				default:
					$this->pricesCurrency = 'RON';
			}
			return true;
		}

		/**
		 * setDiscount
		 *
		 * Sets the global order discount
		 *
		 * @access		public
		 * @param		$discount float
		 * @return		boolean
		 */
		function setDiscount ($discount = 0) {
			if (is_numeric($discount) && $discount >= 0) {
				$this->discount = $discount;
				return true;
			}
			$this->discount = NULL;
			return false;
		}

		/**
		 * setDestinationCity
		 *
		 * @access		public
		 * @param		$destinationCity string
		 * @return		boolean
		 */
		function setDestinationCity ($destinationCity) {
			$destinationCity = trim($destinationCity);
			if (is_string($destinationCity) && strlen($destinationCity) > 0) {
				$this->destinationCity = $destinationCity;
				return true;
			}
			$this->destinationCity = NULL;
			return false;
		}

		/**
		 * setDestinationState
		 *
		 * @access		public
		 * @param		$destinationState string
		 * @return		boolean
		 */
		function setDestinationState ($destinationState) {
			$destinationState = trim($destinationState);
			if (is_string($destinationState) && strlen($destinationState) > 0) {
				$this->destinationState = $destinationState;
				return true;
			}
			$this->destinationState = NULL;
			return false;
		}

		/**
		 * setDestinationCountry
		 *
		 * @access		public
		 * @param		$destinationCountry integer
		 * @return		boolean
		 */
		function setDestinationCountry ($destinationCountry) {
			if (settype($destinationCountry, "string")) {
				if (strlen($destinationCountry) == 2) {
					$this->destinationCountry = $destinationCountry;
					return true;
				}
			}
			$this->destinationCountry = NULL;
			return false;
		}

		/**
		 * setPayMethod
		 *
		 * @access		public
		 * @param		$payMethod string
		 * @return		boolean
		 */
		function setPayMethod ($payMethod) {
			$payMethod = strtoupper($payMethod);
			switch ($payMethod) {
				case 'CCVISAMC':
					$this->payMethod = 'CCVISAMC';
					$retval = true;
					break;

				case 'CCAMEX':
					$this->payMethod = 'CCAMEX';
					$retval = true;
					break;

				case 'CCDINERS':
					$this->payMethod = 'CCDINERS';
					$retval = true;
					break;

				case 'CCJCB':
					$this->payMethod = 'CCJCB';
					$retval = true;
					break;

				case 'WIRE':
					$this->payMethod = 'WIRE';
					$retval = true;
					break;

				case 'CASH':
					$this->payMethod = 'CASH';
					$retval = true;
					break;

				default:
					$this->payMethod = NULL;
					$retval = false;
			}
			return $retval;
		}

		/**
		 * setBilling
		 *
		 * Sets the billing information for the order
		 *
		 * @access		public
		 * @param		$billing array
		 */
		function setBilling ($billing) {
			foreach ($billing as $key => $val)
				$this->billing[$key] = $val;
			$this->billingSet = true;
		}

		/**
		 * setDelivery
		 *
		 * Sets the delivery information for the order
		 *
		 * @access		public
		 * @param		$delivery array
		 */
		function setDelivery ($delivery) {

			while (is_array($delivery) && list($key, $val) = each($delivery)) {
				$$key = $val;
				switch ($key) {
					case 'deliveryCity':
						if (is_string($this->destinationCity) && empty($this->destinationCity))
							$this->delivery[$key] = $val;
						else
							$this->delivery[$key] = $this->destinationCity;
						break;

					case 'deliveryState':
						if (is_string($this->destinationState) && empty($this->destinationState))
							$this->delivery[$key] = $val;
						else
							$this->delivery[$key] = $this->destinationState;
						break;

					case 'deliveryCountryCode':
						if ($this->destinationCountry === 0)
							$this->delivery[$key] = $val;
						else
							$this->delivery[$key] = $this->destinationCountry;
						break;

					default:
						$this->delivery[$key] = $val;
				}
			}
			$this->deliverySet = true;
		}

		/**
		 * getLiveUpdateHTML
		 *
		 * This method returns the HTML code. This will include only the hidden
		 * fields, not the <form></form> tags.
		 *
		 * @access		public
		 * @access		public
		 * @return		string
		 */
		function getLiveUpdateHTML () {
			$htmlCode = "";

			//add reference
			if (is_null($this->merchant))
				$htmlCode = "<!-- EPAYMENT ERROR: Invalid merchant id. -->";
			else
				$htmlCode .= $this->createHiddenField('merchant',$this->merchant, false);

			//add external order ref
			if (!is_null($this->orderRef))
				$htmlCode .= $this->createHiddenField('order_ref',$this->orderRef, false);

			//add order date
			if (is_null($this->orderDate))
				$htmlCode = "<!-- EPAYMENT ERROR: Invalid order date. -->";
			else
				$htmlCode .= $this->createHiddenField('order_date', $this->orderDate, false);

			$sincronized = true;
			if ((count($this->orderPName) == count($this->orderPCode))
				&& (count($this->orderPCode) == count($this->orderPrice))
				&& (count($this->orderPrice) == count($this->orderQty))
				&& (count($this->orderQty) == count($this->orderVAT))) {
				$count = count($this->orderPName);

				if (count($this->orderPInfo))
					if ($count != count($this->orderPInfo))
						$sincronized = false;

				if (count($this->orderVer))
					if ($count != count($this->orderVer))
						$sincronized = false;
						
				if (count($this->orderPGroup))
					if ($count != count($this->orderPGroup))
						$sincronized = false;
				
				if (count($this->orderPType))
					if ($count != count($this->orderPType))
						$sincronized = false;
			} else {
				$sincronized = false;
			}

			if ($sincronized) {
				//add order pname
				if (is_null($this->orderPName) || empty($this->orderPName))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid order name. -->";
				else
					$htmlCode .= $this->createHiddenField('order_pname', $this->orderPName);					
				
				//add order pcode	
				if (is_null($this->orderPGroup))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid order group input. -->";
				elseif (!empty($this->orderPGroup))
					$htmlCode .= $this->createHiddenField('ORDER_PGROUP', $this->orderPGroup);				

				//add order pcode
				if (is_null($this->orderPCode) || empty($this->orderPCode))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid product codes. -->";
				else
					$htmlCode .= $this->createHiddenField('order_pcode', $this->orderPCode);

				//add order pinfo
				if (is_null($this->orderPInfo))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid product info. -->";
				elseif (!empty($this->orderPInfo))
					$htmlCode .= $this->createHiddenField('order_pinfo', $this->orderPInfo);

				//add order prices
				if (is_null($this->orderPrice) || empty($this->orderPrice))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid order prices. -->";
				else
					$htmlCode .= $this->createHiddenField('ORDER_PRICE', $this->orderPrice);
					
				//add order price types
				if (is_null($this->orderPType))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid order price types. -->";
				else
					$htmlCode .= $this->createHiddenField('ORDER_PRICE_TYPE', $this->orderPType);

				//add order qty
				if (is_null($this->orderQty) || empty($this->orderQty))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid quantity. -->";
				else
					$htmlCode .= $this->createHiddenField('order_qty', $this->orderQty);

				//add order vat
				if (is_null($this->orderVAT) || empty($this->orderVAT))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid order vat. -->";
				else
					$htmlCode .= $this->createHiddenField('order_vat', $this->orderVAT);

				//add order ver
				if (is_null($this->orderVer))
					$htmlCode = "<!-- EPAYMENT ERROR: Invalid product versions. -->";
				elseif (!empty($this->orderVer))
					$htmlCode .= $this->createHiddenField('order_ver', $this->orderVer);
			} else {
				return "<!-- EPAYMENT ERROR - sent arrays are not syncronized (variable length) -->";
			}

			//add shipping
			if (is_null($this->orderShipping))
				return "<!-- EPAYMENT ERROR: Invalid shipping value. -->";
			elseif ((is_numeric($this->orderShipping)) && ($this->orderShipping >= 0))
				$htmlCode .= $this->createHiddenField('ORDER_SHIPPING', $this->orderShipping, false);
			else
				$htmlCode .= "";


			//add currency
			if (!empty($this->pricesCurrency))
				$htmlCode .= $this->createHiddenField('PRICES_CURRENCY', $this->pricesCurrency, false);

			//add discount
			if (is_null($this->discount))
				return "<!-- EPAYMENT ERROR: Invalid discount. -->";
			elseif ($this->discount)
				$htmlCode .= $this->createHiddenField('discount', $this->discount, false);

			//add destination city
			if (is_null($this->destinationCity))
				$htmlCode = "<!-- EPAYMENT ERROR: Invalid destination city. -->";
			elseif (!empty($this->destinationCity))
				$htmlCode .= $this->createHiddenField('DESTINATION_CITY', $this->destinationCity, false);

			//add destination state
			if (is_null($this->destinationState))
				return "<!-- EPAYMENT ERROR: Invalid destination state. -->";
			elseif (!empty($this->destinationState))
				$htmlCode .= $this->createHiddenField('DESTINATION_STATE', $this->destinationState, false);

			//add destination country
			if (is_null($this->destinationCountry))
				return "<!-- EPAYMENT ERROR: Invalid destination country code. -->";
			elseif (!empty($this->destinationCountry))
				$htmlCode .= $this->createHiddenField('DESTINATION_COUNTRY', $this->destinationCountry, false);

			//add pay method
			if (!empty($this->payMethod))
				$htmlCode .= $this->createHiddenField('PAY_METHOD', $this->payMethod, false);

			//add order hash
			$hmacHash = $this->hmac($this->secretKey, $this->getHmacString());
			$htmlCode .= $this->createHiddenField('ORDER_HASH', $hmacHash, false);

			//add test mode
			if ($this->testMode)
				$htmlCode .= "<input name=\"TESTORDER\" type=\"hidden\" value=\"TRUE\">\n";

			//add billing information if it is available
			if ($this->billingSet) {
				$billingFields = array(
					"billFName"				=> 'BILL_FNAME',
					"billLName"				=> 'BILL_LNAME',
					"billCISerial"			=> 'BILL_CISERIAL',
					"billCINumber"			=> 'BILL_CINUMBER',
					"billCIIssuer"			=> 'BILL_CIISSUER',
					"billCNP"				=> 'BILL_CNP',
					"billCompany"			=> 'BILL_COMPANY',
					"billFiscalCode" 		=> 'BILL_FISCALCODE',
					"billRegNumber" 		=> 'BILL_REGNUMBER',
					"billBank" 				=> 'BILL_BANK',
					"billBankAccount" 		=> 'BILL_BANKACCOUNT',
					"billEmail" 			=> 'BILL_EMAIL',
					"billPhone" 			=> 'BILL_PHONE',
					"billFax" 				=> 'BILL_FAX',
					"billAddress1"			=> 'BILL_ADDRESS',
					"billAddress2"			=> 'BILL_ADDRESS2',
					"billZipCode"			=> 'BILL_ZIPCODE',
					"billCity"				=> 'BILL_CITY',
					"billState"				=> 'BILL_STATE',
					"billCountryCode"		=> 'BILL_COUNTRYCODE'
				);
				foreach ($this->billing as $key => $val)
					$htmlCode .= $this->createHiddenField($billingFields[$key], $this->billing[$key], false);
			}

			//add delivery information if it is available
			if ($this->deliverySet) {
				$deliveryFields = array(
					"deliveryFName"			=> 'DELIVERY_FNAME',
					"deliveryLName"			=> 'DELIVERY_LNAME',
					"deliveryCompany"		=> 'DELIVERY_COMPANY',
					"deliveryPhone"			=> 'DELIVERY_PHONE',
					"deliveryAddress1"		=> 'DELIVERY_ADDRESS',
					"deliveryAddress2"		=> 'DELIVERY_ADDRESS2',
					"deliveryZipCode"		=> 'DELIVERY_ZIPCODE',
					"deliveryCity"			=> 'DELIVERY_CITY',
					"deliveryState"			=> 'DELIVERY_STATE',
					"deliveryCountryCode"	=> 'DELIVERY_COUNTRYCODE'
				);
				foreach ($this->delivery as $key => $val)
					$htmlCode .= $this->createHiddenField($deliveryFields[$key], $this->delivery[$key], false);
			}

			if (is_string($this->language) && !empty($this->language))
				$htmlCode .= $this->createHiddenField('LANGUAGE', $this->language, false);
    
      if ($this->automode)
				$htmlCode .= $this->createHiddenField('AUTOMODE', '1', false);
      
      if ($this->return_url!="")
				$htmlCode .= $this->createHiddenField('BACK_REF', $this->return_url, false);
      
			return $htmlCode;
		}
    function setReturnURL($url)
    {
      $this->return_url=$url;
    }
		/**
		 * createHiddenField
		 *
		 * @access		private
		 * @param		$fieldName	string	name/id of the hidden field in html code
		 * @param		$fieldValue	string	field/fields value/values
		 * @param		$isArray	bool	specifies if it should generate an array or not
		 * @return 		string	output html code
		 */
		function createHiddenField ($fieldName, $fieldValue, $isArray = true) {
			$fieldName = strtoupper($fieldName);
			$retval = "";
			if ($isArray) {
				for ($i = 0; $i < count($fieldValue); $i++) {
					$fieldValue[$i] = htmlspecialchars($fieldValue[$i]);
					$retval .= "<input name=\"".$fieldName."[]\" type=\"hidden\" value=\"".$fieldValue[$i]."\" id=\"$fieldName\">\n";
					//$retval .= "<input name=\"".$fieldName."[]\" type=\"text\" value=\"".$fieldValue[$i]."\" id=\"$fieldName\">\n";
				}
			} else {
				$fieldValue = htmlspecialchars($fieldValue);
				$retval = "<input name=\"$fieldName\" type=\"hidden\" value=\"$fieldValue\" id=\"$fieldName\">\n";
				//$retval = "<input name=\"$fieldName\" type=\"text\" value=\"$fieldValue\" id=\"$fieldName\">\n";
			}
			return $retval;
		}

		/**
		 * getHmacString
		 *
		 * Creates source string for hmac hash
		 * THIS FUNCTION SHOULD NOT BE MODIFIED.
		 *
		 * @access		private
		 * @return		string
		 */
		function getHmacString () {
			$retval = "";
			$retval .= $this->expandString($this->merchant);
			$retval .= $this->expandString($this->orderRef);
			$retval .= $this->expandString($this->orderDate);
			$retval .= $this->expandArray($this->orderPName);
			$retval .= $this->expandArray($this->orderPCode);
			if (is_array($this->orderPInfo) && !empty($this->orderPInfo))
				$retval .= $this->expandArray($this->orderPInfo);
			$retval .= $this->expandArray($this->orderPrice);
			$retval .= $this->expandArray($this->orderQty);
			$retval .= $this->expandArray($this->orderVAT);
			if (is_array($this->orderVer) && !empty($this->orderVer))
				$retval .= $this->expandArray($this->orderVer);

			//if(!empty($this->orderShipping))
			if (is_numeric($this->orderShipping) && $this->orderShipping >= 0)
				$retval .= $this->expandString($this->orderShipping);

			if (is_string($this->pricesCurrency) && !empty($this->pricesCurrency))
				$retval .= $this->expandString($this->pricesCurrency);
			if (is_numeric($this->discount) && !empty($this->discount))
				$retval .= $this->expandString($this->discount);
			if (is_string($this->destinationCity) && !empty($this->destinationCity))
				$retval .= $this->expandString($this->destinationCity);
			if (is_string($this->destinationState) && !empty($this->destinationState))
				$retval .= $this->expandString($this->destinationState);
			if (is_string($this->destinationCountry) && !empty($this->destinationCountry))
				$retval .= $this->expandString($this->destinationCountry);
			if (is_string($this->payMethod) && !empty($this->payMethod))
				$retval .= $this->expandString($this->payMethod);
			if (is_array($this->orderPGroup) && count($this->orderPGroup))
				$retval .= $this->expandArray($this->orderPGroup);
			if (is_array($this->orderPType) && count($this->orderPType))
				$retval .= $this->expandArray($this->orderPType);
			
			return $retval;
		}

		/**
		 * expandString
		 *
		 * Outputs a string for hmac format. For a string like 'a' it will return '1a'.
		 *
		 * @access		private
		 * @param		$string string
		 * @return 		string
		 */
		function expandString ($string) {
			$retval = "";
			//$string = htmlspecialchars($string);
			$size = strlen($string);
			$retval = $size . $string;
			return $retval;
		}

		/**
		 * expandArray
		 *
		 * The same as expandString except that it receives an array of strings and
		 * returns the string from all values within the array.
		 *
		 * @param		$array array
		 * @return		string
		 */
		function expandArray($array) {
			$retval = "";
			for ($i = 0; $i < count($array); $i++)
				$retval .= $this->expandString($array[$i]);
			return $retval;
		}

		/**
		 * hmac
		 *
		 * Build HMAC key. THIS FUNCTION SHOULD NOT BE MODIFIED.
		 *
		 * @param		$array string secret key
		 * @param		@data string the source string that will be converted into hmac hash
		 * @return		string hmac hash
		 */
		function hmac ($key, $data) {
		   $b = 64; // byte length for md5
		   if (strlen($key) > $b) {
			   $key = pack("H*",md5($key));
		   }
		   $key  = str_pad($key, $b, chr(0x00));
		   $ipad = str_pad('', $b, chr(0x36));
		   $opad = str_pad('', $b, chr(0x5c));
		   $k_ipad = $key ^ $ipad ;
		   $k_opad = $key ^ $opad;
		   return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
		}
	}
// No closing tag
