<?php
ini_set("display_errors",0);
error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * PayU Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2013 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 August 2012
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');



class plgVmPaymentPayuForVirtuemart extends vmPSPlugin {

	public static $_this = false;
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment PayU Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
	    'id' => ' INT(11) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' => ' int(1) UNSIGNED DEFAULT NULL',
	    'order_number' => ' char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' => ' mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' => 'varchar(5000)',
	    'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' => 'char(3) ',
	    //'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
	    //'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
	    //'tax_id' => ' smallint(1) DEFAULT NULL'
		);
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=payuforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'payulic'=>$lic),'payuforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your PayU - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('payuforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['payulic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your PayU - Payment Gateway License Code', 'error');
        $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          if($chk!=$dchk)//check
          {
            $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
            $application->enqueueMessage('Provided License code is wrong', 'error');
            return;
          }
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->payu_user)) {
			vmInfo(JText::_('PayU Merchant ID Missing!!!'));
			return false;
		}
		if (empty($method->payu_password)) {
			vmInfo(JText::_('PayU Secret Key Missing!!!'));
			return false;
		}

		$myKey = $method->payu_password;
		$myId = $method->payu_user;

    $myOrderRef	= $order['details']['BT']->order_number;
	  $myOrderDate = date("Y-m-d H:i:s");
	  
    $PayU_button='Click here to Pay';
    
    $vat_amnt=0;
    if(isset($order['details']['BT']->order_billTax))
    {
      $tmp_arr=json_decode($order['details']['BT']->order_billTax);
      $one="1";
      if(isset($tmp_arr->$one))
      {
        $vat_amnt=$tmp_arr->$one->calc_value;
      }
      $vat_amnt=round($vat_amnt);
    }
    
    $langs_arr=array('IN','ES','PT');
    
	  $return_url= JURI::root(). 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid');
  	$bill_total=round($order['details']['BT']->order_total,2);
    $signature=md5("$myKey~$myId~$myOrderRef~$bill_total~$currency_code_3");
    $post_variables = Array
    (
    "merchantId"=>$myId,
    "referenceCode"=>$myOrderRef,
    "description"=>"Your " . $_SERVER['HTTP_HOST']." order.",
    "amount"=>$bill_total,
    "tax"=>0,
    "taxReturnBase"=>0,
    //"accountId"=>,
    "signature"=>$signature,
    "currency"=>$currency_code_3,
    "buyerEmail"=>$usrBT->email,
    "payerFullName"=> $usrBT->first_name . " " . $usrBT->last_name,
    "billingAddress"=>$usrBT->address_1." ".$usrBT->address_2,
    "shippingAddress"=>$usrST->address_1." ".$usrST->address_2,
    "telephone"=>$usrBT->phone_1,
    "billingCity"=>$usrBT->city,
    "shippingCity"=>$usrST->city,
    "zipCode"=>$usrBT->zip,
    "billingCountry"=>ShopFunctions::getCountryByID($usrBT->virtuemart_country_id,"country_2_code"),
    "shippingCountry"=>ShopFunctions::getCountryByID($usrST->virtuemart_country_id,"country_2_code"),
    "buyerFullName"=> $usrBT->first_name . " " . $usrBT->last_name,
    "payerEmail"=>$usrBT->email,
    "payerPhone"=>$usrBT->phone_1,
    "responseUrl"=>$return_url,
    "confirmationUrl"=>JURI::root().'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component'
    );

    if($method->payu_accountId!="")
    {
      $post_variables["accountId"]=$method->payu_accountId;
    }
    $payu_new_url='https://gateway.payulatam.com/ppp-web-gateway/';
  	if($method->payu_test=='TEST')
	  {
	    $post_variables["test"]=1;
      $payu_new_url='https://stg.gateway.payulatam.com/ppp-web-gateway/';
	  }
		$html = '<div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PayUfrm" id="PayUfrm" action="'.$payu_new_url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html.= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$PayU_button.'" />';
		$html.= '</form></div>';
		//$html.=htmlentities($strPost);
		
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PayUfrm.submit();';
		$html.= ' </script>';
		
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		//$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		//$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		//$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		return true;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	
	  if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		$payment_name = $this->renderPluginName($method);
    
    $ApiKey		= $method->payu_password;	/* pass to compute HASH */
    
    $merchant_id=$_REQUEST['merchantId'];
    $referenceCode=$_REQUEST['referenceCode'];
    $TX_VALUE=$_REQUEST['TX_VALUE'];
    $New_value=number_format($TX_VALUE, 2);
    $currency=$_REQUEST['currency'];
    $transactionState=$_REQUEST['transactionState'];
    $firma_cadena= "$ApiKey~$merchant_id~$referenceCode~$New_value~$currency~$transactionState";

    $firmacreada = md5($firma_cadena);//firma que generaron ustedes
    $firma =$_REQUEST['signature'];//firma que envía nuestro sistema 
    $reference_pol=$_REQUEST['reference_pol'];
    $cus=$_REQUEST['cus'];
    $extra1=$_REQUEST['description'];
    $pseBank=$_REQUEST['pseBank'];
    $lapPaymentMethod=$_REQUEST['lapPaymentMethod'];
    $transactionId=$_REQUEST['transactionId'];

    if($_REQUEST['transactionState'] == 6 && $_REQUEST['polResponseCode'] == 5)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 6 && $_REQUEST['polResponseCode'] == 4)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 12 && $_REQUEST['polResponseCode'] == 9994)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 4 && $_REQUEST['polResponseCode'] == 1)
    {$order_paid = 1;}
    else
    {$order_paid = 0;}

    //if(strtoupper($firma)==strtoupper($firmacreada)) //seams to be some issues, bad documentation
    $modelOrder = VmModel::getModel('orders');
		$order = array();

		$order['customer_notified'] = 1;

		if ($order_paid == 1) {
			$order['order_status'] = $method->status_success;
		}
    else
    {
      $order['order_status'] = $method->status_canceled;
    }

		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
    
    $html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return TRUE;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getPaymentStatus($method, $strStatus) {
		$new_status = '';
		if (strcmp($strStatus, 'OK') == 0) {
			$new_status = $method->status_success;
		}
    elseif (strcmp($strStatus, 'ABORT') == 0) {
			$new_status = $method->status_pending;
		}
    else {
			$new_status = $method->status_canceled;
		}
		return $new_status;
	}
	
	function _getPayuInternalData($virtuemart_order_id, $order_number='') {
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $paymentTable;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
  
    $db = &JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Thank You!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
		return $html;
	}
	function ArrayExpand($array){
  	$retval = "";
  	for($i = 0; $i < sizeof($array); $i++){
  		$size		= strlen(StripSlashes($array[$i]));
  		$retval	.= $size.StripSlashes($array[$i]);
  	}
  
  	return $retval;
  }
  function sendMailtoAdmin($msg)
  {
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->getValue( 'config.mailfrom' ),
        $config->getValue( 'config.fromname' ) );
     
    $mailer->setSender($sender);
    
    $mailer->addRecipient($config->getValue( 'config.mailfrom' ));
    $body   = $msg;
    $mailer->setSubject(juri::base().' - PayU Warning!');
    $mailer->isHTML(true);
    $mailer->Encoding = 'base64';
    $body=nl2br($body);
    $mailer->setBody($body);
    $send = $mailer->Send();
  }
	function plgVmOnPaymentNotification() {

    if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		if (!isset($_REQUEST['referenceCode'])) {
			return FALSE;
		}

		$order_number = $_REQUEST['referenceCode'];
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($_REQUEST['referenceCode']))) {
			return FALSE;
		}

		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return FALSE;
		}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
    
    $ApiKey		= $method->payu_password;	/* pass to compute HASH */
    
    $merchant_id=$_REQUEST['merchantId'];
    $referenceCode=$_REQUEST['referenceCode'];
    $TX_VALUE=$_REQUEST['TX_VALUE'];
    $New_value=number_format($TX_VALUE, 2);
    $currency=$_REQUEST['currency'];
    $transactionState=$_REQUEST['transactionState'];
    $firma_cadena= "$ApiKey~$merchant_id~$referenceCode~$New_value~$currency~$transactionState";
    
    $firmacreada = md5($firma_cadena);//firma que generaron ustedes
    $firma =$_REQUEST['signature'];//firma que envía nuestro sistema 
    $reference_pol=$_REQUEST['reference_pol'];
    $cus=$_REQUEST['cus'];
    $extra1=$_REQUEST['description'];
    $pseBank=$_REQUEST['pseBank'];
    $lapPaymentMethod=$_REQUEST['lapPaymentMethod'];
    $transactionId=$_REQUEST['transactionId'];

    if($_REQUEST['transactionState'] == 6 && $_REQUEST['polResponseCode'] == 5)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 6 && $_REQUEST['polResponseCode'] == 4)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 12 && $_REQUEST['polResponseCode'] == 9994)
    {$order_paid = 0;}
    else if($_REQUEST['transactionState'] == 4 && $_REQUEST['polResponseCode'] == 1)
    {$order_paid = 1;}
    else
    {$order_paid = 0;}
    //if(strtoupper($firma)==strtoupper($firmacreada)) //seams to be some issues, bad documentation
    if($order_paid==1)
    {
      $modelOrder = VmModel::getModel('orders');
  		$order = array();
  
  		$order['customer_notified'] = 1;
  
  		if ($order_paid == 1) {
  			$order['order_status'] = $method->status_success;
  		}
      else
      {
        $order['order_status'] = $method->status_canceled;
      }
  
  		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
    }
    exit;
	}
	function hmac ($key, $data) {
	   $b = 64; // byte length for md5
	   if (strlen($key) > $b) {
		   $key = pack("H*",md5($key));
	   }
	   $key  = str_pad($key, $b, chr(0x00));
	   $ipad = str_pad('', $b, chr(0x36));
	   $opad = str_pad('', $b, chr(0x5c));
	   $k_ipad = $key ^ $ipad ;
	   $k_opad = $key ^ $opad;
	   return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
	}
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
	/*
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount > 0);
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id']))
		$address['virtuemart_country_id'] = 0;
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return true;
			}
		}

		return false;
		*/
		return true;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}
	
// No closing tag
