<?php
defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * PayU LATAM Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2014 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Sept 2014
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');



class plgVmPaymentPayuForVirtuemart extends vmPSPlugin {

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		$this->_loggable = TRUE;
		$this->_debug = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = array(
    'payu_user'           => array('', 'char'),
    'payu_password'       => array('', 'char'),
    'payu_accountId'      => array('', 'char'),
    'payu_test'           => array('', 'char'),
    'payment_logos'       => array('', 'char'),
    'countries'           => array('', 'char'),
    'cost_per_transaction'=> array('', 'int'),
    'cost_percent_total'  => array('', 'int'),
    'min_amount'          => array('', 'int'),
    'max_amount'          => array('', 'int'),
    'tax_id'              => array(0, 'int'),
    'status_pending'      => array('', 'char'),
    'status_success'      => array('', 'char'),
    'status_canceled'     => array('', 'char'));
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment PayU Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
    'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
		'virtuemart_order_id' => 'int(1) UNSIGNED',
		'order_number' => 'char(64)',
		'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
		'payment_name' => 'varchar(5000)',
		'payment_order_total' => 'decimal(15,5) NOT NULL',
		'payment_currency' => 'smallint(1)',
    'payment_order_total'     => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
		'cost_per_transaction' => 'decimal(10,2)',
		'cost_percent_total' => 'decimal(10,2)',
		'tax_id' => 'smallint(1)',
    );
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=payuforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'payulic'=>$lic),'payuforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your PayU - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('payuforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['payulic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your PayU - Payment Gateway License Code', 'error');
        $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          //$chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          //if($chk!=$dchk)//check
          //{
          //  $this->setParams(array('payulic'=>'','dchk'=>''),'payuforvirtuemart');
          //  $application->enqueueMessage('Provided License code is wrong', 'error');
          //  return;
          //}
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
    
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->payu_user)) {
			vmInfo(JText::_('PayU Merchant ID Missing!!!'));
			return false;
		}
		if (empty($method->payu_password)) {
			vmInfo(JText::_('PayU Secret Key Missing!!!'));
			return false;
		}

		$myKey = $method->payu_password;
		$myId = $method->payu_user;

    $myOrderRef	= $order['details']['BT']->order_number;
	  $myOrderDate = date("Y-m-d H:i:s");
	  
    $PayU_button='Click here to Pay';
    
    ////////////////////////////////////////////////////////////////////////////
    $vat_amnt=0;

    if (!class_exists('VirtueMartCart'))
    require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
    $cart = VirtueMartCart::getCart();

    $discount_val=0;
    $discount_val=@$cart->cartPrices['couponValue']+0;
    if($discount_val>0)
    {
      $discount_val=$discount_val*-1;
    }
    $discount_val=round($discount_val,2);
    
    if(!empty($cart->cartData['VatTax'])){
			reset($cart->cartData['VatTax']);
			$taxd = current($cart->cartData['VatTax']);
			$vat_amnt = rtrim(trim($taxd['calc_value'],'0'),'.');
		}
    
    $bill_total=round($cart->cartPrices['salesPricePayment']+
    $cart->cartPrices['salesPriceShipment']+
    $cart->cartPrices['salesPrice']+
    $discount_val);
    
    $tmp="1".$vat_amnt;
    $actual_coupon=(($discount_val*-1)/$tmp)*100;
    
    $tmp="0.".$vat_amnt;
    $actual_tax=round(($cart->cartPrices['discountedPriceWithoutTax']-$actual_coupon)*$tmp);
    ////////////////////////////////////////////////////////////////////////////
        
    $langs_arr=array('IN','ES','PT');

	  $return_url= JURI::root(). 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid');
  	//$bill_total=round($order['details']['BT']->order_total,2);
    $subtotal=round(($order['details']['BT']->order_subtotal+$order['details']['BT']->order_shipment+$order['details']['BT']->order_payment),2);
    $signature=md5("$myKey~$myId~$myOrderRef~$bill_total~$currency_code_3");
    $post_variables = Array
    (
    "merchantId"=>$myId,
    "referenceCode"=>$myOrderRef,
    "description"=>"sale " . $myOrderRef,
    "amount"=>$bill_total,
    "tax"=>$actual_tax,
    "taxReturnBase"=>"0",
    "discount"=>"0",
    "signature"=>$signature,
    "currency"=>$currency_code_3,
    "buyerEmail"=>$usrBT->email,
    "payerFullName"=> $usrBT->first_name . " " . $usrBT->last_name,
    "billingAddress"=>$usrBT->address_1." ".$usrBT->address_2,
    "shippingAddress"=>$usrST->address_1." ".$usrST->address_2,
    "telephone"=>$usrBT->phone_1,
    "billingCity"=>$usrBT->city,
    "shippingCity"=>$usrST->city,
    "zipCode"=>$usrBT->zip,
    "billingCountry"=>ShopFunctions::getCountryByID($usrBT->virtuemart_country_id,"country_2_code"),
    "shippingCountry"=>ShopFunctions::getCountryByID($usrST->virtuemart_country_id,"country_2_code"),
    "buyerFullName"=> $usrBT->first_name . " " . $usrBT->last_name,
    "payerEmail"=>$usrBT->email,
    "payerPhone"=>$usrBT->phone_1,
    "responseUrl"=>$return_url,
    "confirmationUrl"=>JURI::root().'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component'
    );

    if($method->payu_accountId!="")
    {
      $post_variables["accountId"]=$method->payu_accountId;
    }
  	$payu_new_url='https://gateway.payulatam.com/ppp-web-gateway/';
  	if($method->payu_test=='TEST')
	  {
	    $post_variables["test"]=1;
      $payu_new_url='https://stg.gateway.payulatam.com/ppp-web-gateway/';
	  }
		$html = '<div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form name="PayUfrm" id="PayUfrm" action="'.$payu_new_url.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html.= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$PayU_button.'" />';
		$html.= '</form></div>';
		//$html.=htmlentities($strPost);
		
		$html.= ' <script type="text/javascript">';
		$html.= ' document.PayUfrm.submit();';
		$html.= ' </script>';
		
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		//$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		return true;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	function plgVmOnPaymentResponseReceived(&$html) {

		if (!class_exists('VirtueMartCart')) {
      require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
    }
    if (!class_exists('shopFunctionsF')) {
      require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
    }
    if (!class_exists('VirtueMartModelOrders')) {
      require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
    }
    VmConfig::loadJLang('com_virtuemart_orders',TRUE);
		
		$values = $this->_getResponsePayuValues();
		
    $vendorId = 0;
		$payMethod = $_REQUEST['pm'];

    if (!($this->_currentMethod = $this->getVmPluginMethod($payMethod))) {
      return NULL; // Another method was selected, do nothing
    }

    if (!$this->selectedThisElement($this->_currentMethod->payment_element)) {
      return NULL;
    }

    if (!($virtuemartOrderId = VirtueMartModelOrders::getOrderIdByOrderNumber($values['referenceCode']))) {
      return NULL;
		}

		$paymentName = $this->renderPluginName($this->_currentMethod);

		VmConfig::loadJLang('com_virtuemart');
    $orderModel = VmModel::getModel('orders');
    $order = $orderModel->getOrder($virtuemartOrderId);

		if (!class_exists('CurrencyDisplay'))
      require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');

    $currency = CurrencyDisplay::getInstance('',$order['details']['BT']->virtuemart_vendor_id);
		
		$success = $values['transactionState'] == '4' || $values['transactionState'] == '7';

		if(!isset($success)) $success = false;

		$html = $this->renderByLayout('response', array("success" => $success,
	                                                                                        "payment_name" => $paymentName,
                                                                                          "order" => $order,
																																													"values" => $values,
                                                                                          "currency" => $currency,
                                                                                     ));

		$cart = VirtueMartCart::getCart();
    $cart->emptyCart();
    return TRUE;

  }

  function _getResponsePayuValues() {

		$fields = array(
    	"merchantId" => "usuario_id",
    	"merchant_name" => "usuario_nombre",
    	"merchant_address" => "usuario_direccion",
    	"telephone" => "telefono",
    	"merchant_url" => "usuario_url",
    	"transactionState" => "estado",
    	"lapTransactionState" => "estado_lap",
    	"message" => "mensaje",
    	"referenceCode" => "ref_venta",
    	"reference_pol" => "ref_pol",
    	"transactionId" => "transaction_id",
    	"description" => "descripcion",
    	"trazabilityCode" => "trazability_code",
    	"cus" => "cus",
    	"orderLanguage" => "idioma",
    	"extra1" => "extra1",
    	"extra2" => "extra2",
    	"extra3" => "extra3",
    	"signature" => "firma",
    	"polResponseCode" => "codigo_respuesta_pol",
    	"lapResponseCode" => "codigo_respuesta_lap",
    	"risk" => "riesgo",
    	"polPaymentMethod" => "medio_pago",
    	"lapPaymentMethod" => "medio_pago_lap",
    	"polPaymentMethodType" => "tipo_medio_pago",
    	"lapPaymentMethodType" => "tipo_medio_pago_lap",
    	"installmentsNumber" => "cuotas",
    	"TX_VALUE" => "valor",
    	"TX_TAX" => "iva",
    	"currency" => "moneda",
    	"lng" => "lng",
    	"pseCycle" => "ciclo_pse",
    	"buyerEmail" => "emailComprador",
    	"pseBank" => "banco_pse",
    	"pseReference1" => "pseReferencia1",
			"pseReference2" => "pseReferencia2",
    	"pseReference3" => "pseReferencia3",
    	"authorizationCode" => "codigo_autorizacion",
    	"TX_ADMINISTRATIVE_FEE" => "tarifa_administrativa",
    	"TX_TAX_ADMINISTRATIVE_FEE" => "iva_tarifa_administrativa",
    	"TX_TAX_ADMINISTRATIVE_FEE_RETURN_BASE" => "base_tarifa_administrativa",
    	"processingDate" => "fecha_procesamiento",
    	"cc_number" => "numero_visible",
    	"cc_holder" => "tarjeta_habiente",
    	"request_number" => "numero_pedido",
    	"processing_date_time" => "fecha_hora_procesamiento",
    	"action_code_description" => "descripcion_codigo_accion"
  	);
	
		$values = array();

  	foreach($fields as $key => $value) {
    	$val = ( isset($_REQUEST[$key]) )? $_REQUEST[$key] : $_REQUEST[$value];
    	if(isset($val)) {
      	$values[$key] = $val;
    	}
  	}

		return $values;

	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
  
    $db = &JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Thank You!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
		return $html;
	}


	public function plgVmOnPaymentNotification() {
		if (!class_exists('VirtueMartModelOrders')) {
      require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
    }
		$values = $this->_getConfirmationPayuValues();
		
		$orderId = $values['reference_sale'];
		
		if (!($virtuemartOrderId = VirtueMartModelOrders::getOrderIdByOrderNumber($orderId))) {
      return NULL;
		}
		
		if(!($payment = $this->getDataByOrderId($virtuemartOrderId)) ) {
			return FALSE;
		}
		
		$this->_currentMethod = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($this->_currentMethod->payment_element) ) {
			return FALSE;
		}
		
		$orderModel = VmModel::getModel('orders');
		
		$order = $orderModel->getOrder($virtuemartOrderId);
		
		$result = $this->_validatePayment($values);
		
		if(!$result) {
			return FALSE;
		} else {
			$orderModel->updateStatusForOneOrder($virtuemartOrderId, $result, TRUE);
		}
		
		return true;
  }
  
  function _getSignMd5($values, $val) {
		return md5($this->_currentMethod->payu_password . '~' . $values['merchant_id'] . '~' . $values['reference_sale'] . '~' .
			$val . '~' . $values['currency'] . '~' . $values['state_pol']);
	}
  function _validatePayment($values) {
		$result = array();
		$result['customer_notified'] = 1;
		
		// validate signature
		
		// if second decimal of value is zero we round to 1 decimal
		$val = number_format($values['value'], 1, '.', '');
		$signMd5 = $this->_getSignMd5($values, $val);
		
		if(strtoupper($values['sign']) != strtoupper($signMd5) ){
			// try with two
			$val = number_format($values['value'], 2, '.', '');
			$signMd5 = $this->_getSignMd5($values, $val,$ApiKey);
			
			if(strtoupper($values['sign']) != strtoupper($signMd5) ) {
				return FALSE;
			}
		}
		
		// validate transaction state
		$trxState = $values['state_pol'];
		
		if($trxState == '6' || $trxState == '5' || $trxState == '104') {
			$result['order_status'] = $this->_currentMethod->status_canceled;
		} elseif($trxState == '4') {
			$result['order_status'] = $this->_currentMethod->status_success;
		} else {
			$result['order_status'] = $this->_currentMethod->status_pending;
		}
		
		$result['comments'] = '';
		
		return $result;
	}
  
	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
  function _getConfirmationPayuValues() {

		$fields = array(
    	"nickname_buyer" => "nickname_comprador",
    	"nickname_seller" => "nickname_vendedor",
    	"transaction_id" => "transaccion_id",
    	"merchant_id" => "usuario_id",
    	"date" => "fecha",
    	"transaction_date" => "fecha_transaccion",
    	"payment_request_state" => "estado_transaccion",
    	"sign" => "firma",
    	"test" => "prueba",
    	"reference_sale" => "ref_venta",
    	"reference_pol" => "ref_pol",
    	"airline_code" => "codigo_aerolinea",
    	"description" => "descripcion",
    	"ip" => "ip",
    	"extra1" => "extra1",
    	"extra2" => "extra2",
    	"attempts" => "intentos",
			"currency" => "moneda",
    	"state_pol" => "estado_pol",
    	"email_buyer" => "email_comprador",
    	"exchange_rate" => "tasa_cambio",
    	"value" => "valor",
    	"additional_value" => "valorAdicional",
    	"tax" => "iva",
    	"error_message_bank" => "mensaje_error_banco",
    	"error_code_bank" => "codigo_error_banco",
    	"pse_reference1" => "pse_referencia1",
    	"pse_reference2" => "pse_referencia2",
			"pse_reference3" => "pse_referencia3",
    	"risk" => "riesgo",
    	"response_code_pol" => "codigo_respuesta_pol",
    	"response_message_pol" => "mensaje_respuesta_pol",
    	"billing_address" => "direccionCobro",
    	"billing_city" => "ciudadCobro",
    	"billing_country" => "paisCobro",
    	"shipping_address" => "direccionEnvio",
			"shipping_city" => "ciudadEnvio",
    	"shipping_country" => "paisEnvio",
    	"phone" => "telefono",
    	"office_phone" => "telefonoOficina",
    	"cus" => "cus",
    	"pse_bank" => "banco_pse",
    	"customer_number" => "numeroCliente",
    	"bank_id" => "banco_id",
    	"payment_method_id" => "medio_pago_id",
    	"payment_method" => "medio_pago",
    	"payment_method_type" => "tipo_medio_pago",
    	"installments_number" => "cuotas",
			"account_number_ach" => "numero_cuenta_deb_ach",
			"account_type_ach" => "tipo_cuenta_deb_ach",
			"bank_id_ach" => "banco_id_deb_ach",
			"administrative_fee" => "tarifa_administrativa",
			"administrative_fee_tax" => "iva_tarifa_administrativa",
			"administrative_fee_base" => "base_tarifa_administrativa",
			"commision_pol" => "comision_pol",
			"commision_pol_currency" => "moneda_comision_pol",
			"transaction_bank_id" => "transaccion_banco_id",
			"authorization_code" => "codigo_autorizacion"
  	);
	
		$values = array();

  	foreach($fields as $key => $value) {
    	$val = ( isset($_REQUEST[$key]) )? $_REQUEST[$key] : $_REQUEST[$value];
    	if(isset($val)) {
      	$values[$key] = $val;
    	}
  	}

		return $values;

	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
	  $this->convert_condition_amount($method);

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $this->getCartAmount($cart_prices);
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}
    
		return FALSE;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $paymentCounter);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}
	
// No closing tag
